//
//  Context.h
//  BouncingBallWithOde
//

#ifndef BouncingBallWithAnalyzer_Context_h
#define BouncingBallWithAnalyzer_Context_h

#include <XnCppWrapper.h>
#include <boost/shared_ptr.hpp>
#include <boost/noncopyable.hpp>
#include <boost/thread.hpp>

// singleton
class Context : private boost::noncopyable
{
public:
        void initialize();
        static boost::shared_ptr<Context> get_instance();
        void set_global_mirror(bool flag);
        void enumerate_production_trees(xn::NodeInfoList& nodes, XnProductionNodeType type);
        void create_production_tree(xn::NodeInfo& info);
        void enumerate_existing_nodes(xn::NodeInfoList& node_info_list);
        void wait_any_update_all();
        void wait_and_update_all();
        void start_generating_all();

private:
        static boost::shared_ptr<Context> instance_;
        xn::Context             context_;
        xn::ScriptNode          script_node_;
        // introduce a mutex because of more than one viewer
        mutable boost::mutex    mutex_;
        Context();
};
#endif
